;       ----------------------------------------------------

;    Lickshot! - version 0.1
;    Copyright 2009 Don Miller
;    For more information, visit: http://www.no-carrier.com

;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.

;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.

;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <http://www.gnu.org/licenses/>.

;       ----------------------------------------------------

buttons EQU $c0
oldbuttons EQU $c1
justpressed EQU $c2

freq EQU $c3

;       ----------------------------------------------------

        .ORG $7ff0
Header:                         ; 16 byte .NES header (iNES format)
	.db "NES", $1a
	.db $02                 ; size of PRG ROM in 16kb units
	.db $01			; size of CHR ROM in 8kb units
	.db #%00000000		; mapper 0
	.db #%00000000		; mapper 0
        .db $00                 ; size of PRG RAM in 8kb RAM
        .db $00
        .db $00
        .db $00
        .db $00
        .db $00
        .db $00
        .db $00

        .org $8000

;       ----------------------------------------------------

Reset:                          ; reset routine
        SEI
        CLD
	LDX #$00
	STX $2000
	STX $2001
	DEX
	TXS
  	LDX #0
  	TXA
ClearMemory:
	STA 0, X
	STA $100, X
	STA $200, X
	STA $300, X
	STA $400, X
	STA $500, X
	STA $600, X
	STA $700, X
        STA $800, X
        STA $900, X
        INX
	BNE ClearMemory

;       ----------------------------------------------------

        lda #$00                ; setting up variables
        sta buttons
        sta oldbuttons
        sta justpressed

        lda #$0f
        sta freq

;       ----------------------------------------------------

	LDX #$02                ; warm up
WarmUp:
	bit $2002
	bpl WarmUp
	dex
	BNE WarmUp

       	LDA #$3F
	STA $2006
	LDA #$00
	STA $2006
load_pal:                       ; load palette
        LDA palette,x
        sta $2007
        inx
        cpx #$20
        bne load_pal

	LDA #$20
	STA $2006
	LDA #$00
	STA $2006

	ldy #$04                ; clear nametables
ClearName:
	LDX #$00
	LDA #$00
PPULoop:
	STA $2007
	DEX
	BNE PPULoop

	DEY
	BNE ClearName

;       ----------------------------------------------------

   	LDA #$20                ; draw screen
    	STA $2006
    	LDA #$00
    	STA $2006

        ldy #$00
        ldx #$04

        lda #<screen
        sta $10
        lda #>screen
        sta $11

NameLoop:
        lda ($10),y
        sta $2007
        iny
        bne NameLoop
        inc $11
        dex
        bne NameLoop

;       ----------------------------------------------------

Vblank:                         ; turn on the screen and start the party
	bit $2002
	bpl Vblank

	LDA #%10001000
	STA $2000
        LDA #%00001110
	STA $2001

        ldx #$00
        stx $2005
        stx $2005

;       ----------------------------------------------------

InfLoop:                        ; loop forever
        JMP InfLoop

;       ----------------------------------------------------

controller_test:

	LDA buttons
	sta oldbuttons

        ldx #$00
	LDA #$01		; strobe joypad
	STA $4016
	LDA #$00
	STA $4016
con_loop:
	LDA $4016		; check the state of each button
	LSR
	ROR buttons
        INX
        CPX #$08
        bne con_loop

	LDA oldbuttons
	EOR #$FF
	AND buttons
	STA justpressed

CheckUp:
	LDA #%00010000
	AND justpressed
	BEQ CheckDown

        inc freq
        lda freq
        cmp #$10
        bne CheckDown
        lda #$0f
        sta freq

CheckDown:
	LDA #%00100000
	AND justpressed
	BEQ CheckLeft

        dec freq
        lda freq
        cmp #$ff
        bne CheckLeft
        lda #$00
        sta freq

CheckLeft:
	LDA #%01000000
	AND justpressed
	BEQ CheckRight

        ; does nothing right now

CheckRight:
	LDA #%10000000
	AND justpressed
	BEQ CheckSel

        ; does nothing right now

CheckSel:
	LDA #%00000100
	AND justpressed
	BEQ CheckStart

        LDA #$00
        STA $4015               ; DMC enable
        LDA freq
        sta $4010               ; DMC sample frequency
        lda #$00
        sta $4012               ; DMC sample at $C000
        LDA #$95
        STA $4013               ; DMC sample length
                                ; $4013 = %LLLLLLLL0001
                                ;         %100101011001        - add zeros to the left to line it up
        LDA #$11
        STA $4015               ; DMC sample start

CheckStart
	LDA #%00001000
	AND justpressed
	BEQ CheckB

        LDA #$00
        STA $4015               ; DMC enable
        LDA freq
        sta $4010               ; DMC sample frequency
        lda #$40
        sta $4012               ; DMC sample at $D000
        LDA #$40
        STA $4013               ; DMC sample length
                                ; $4013 = %LLLLLLLL0001
                                ;         %010000000001       - add zeros to the left to line it up
        LDA #$11
        STA $4015               ; DMC sample start

CheckB:
	LDA #%00000010
	AND justpressed
	BEQ CheckA

        LDA #$00
        STA $4015               ; DMC enable
        LDA freq
        sta $4010               ; DMC sample frequency
        lda #$80
        sta $4012               ; DMC sample at $E000
        LDA #$5c
        STA $4013               ; DMC sample length
                                ; $4013 = %LLLLLLLL0001
                                ;         %010111000001        - add zeros to the left to line it up
        LDA #$11
        STA $4015               ; DMC sample start

CheckA:
	LDA #%00000001
	AND justpressed
	BEQ CheckOver

        LDA #$00
        STA $4015               ; DMC enable
        LDA freq
        sta $4010               ; DMC sample frequency
        lda #$C0
        sta $4012               ; DMC sample at $F000
        LDA #$EA
        STA $4013               ; DMC sample length
                                ; $4013 = %LLLLLLLL0001
                                ;         %111010100001        - add zeros to the left to line it up
        LDA #$11
        STA $4015               ; DMC sample start

CheckOver:
        RTS

;       ----------------------------------------------------

NMI:
        jsr controller_test
        RTI
IRQ:
        RTI

;       ----------------------------------------------------

palette:
	;BG
	.byte $0F,$16,$28,$19,$0F,$0F,$0F,$30,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	;SPR
	.byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F

;       ----------------------------------------------------

screen:
        .incbin "lickshot.nam"

;       ----------------------------------------------------

        .org $C000
        .incbin "laser.dmc"               ; 2393 bytes
        .org $D000
        .incbin "TMNT3_Hey.dmc"           ; 1025 bytes
        .org $E000
        .incbin "TopGunDF_BeatThemUp.dmc" ; 1473 bytes
        .org $F000
        .incbin "horn.dmc"                ; 3745 bytes

;       ----------------------------------------------------

	.ORG $fffa
	.dw NMI
	.dw Reset
	.dw IRQ

;       ----------------------------------------------------